<?php

namespace STM\Country;

use \Exception;
use STM\StmFactory;

/**
 * Test class for CountryValidator.
 * Generated by PHPUnit on 2012-02-13 at 10:58:09.
 * @group team_country
 */
class CountryValidatorTest extends \PHPUnit_Framework_TestCase {

    protected function setUp() {
        CountryValidator::init();
    }

    public function testCheck_create() {
        // must array with key countr (string <2, 40>)
        parent::assertTrue(CountryValidator::checkCreate(array('country' => 'CR')));
        parent::assertTrue(CountryValidator::checkCreate(array('country' => 'Country')));
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', array('country' => 'a'));
    }
    public function testCheck_country_name() {
        parent::assertTrue(CountryValidator::checkCountryName('CR'));
        parent::assertTrue(CountryValidator::checkCountryName('Country'));        
        // string 2,40
        $this->assert_bad_arguments('checkCountryName', null);
        $this->assert_bad_arguments('checkCountryName', array());
        $this->assert_bad_arguments('checkCountryName', new Exception());
        $this->assert_bad_arguments('checkCountryName', '12345678901234567890123456789012345678901');
        
        // different from current name or existing country
        foreach (StmFactory::find()->Country->findAll() as $country) {
            CountryValidator::setCountry($country);
            $this->assert_bad_arguments('checkCountryName', $country->__toString());
            CountryValidator::resetCountry();
        }
    }
    
    private function assert_bad_arguments($method, $data) {
        CountryValidator::init();
        parent::assertFalse(CountryValidator::$method($data));
        CountryValidator::init();
    }

}

?>
